// OK. - toate testele
// sa schimb cin, cout in fin fout
 
#include <fstream>
#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

ofstream fout("tree.out");
#define INF 99999

typedef vector<int> VI;

int n, P;
VI t;
VI nr;     // nr[x] - nr noduri ale intregului subarbore cu rad in x
VI sons;
int minim = INF;

void Read();
VI DF(int x);


int main()
{
	Read();
	
	if ( P == n )
	{
		cout << 0 << '\n';
		fout.close();
		return 0;
	}
	VI res = DF(1);
	
	cout << minim << '\n';
	
	fout.close();
	return 0;
}

VI DF(int x)
{
	nr[x]++;
	VI A(n + 1, INF);
	A[1] = sons[x]; // ca sa raman doar cu nodul x in subarbore, tai muchiile spre fii
	if ( x != 1 ) 
		A[1]++;  // daca nu e radacina, tai si nodul spre tata
	for (int f = 1; f <= n; ++f )
		if ( t[f] == x )
		{	
			VI B = DF(f);
			nr[x] += nr[f];
			VI C(A); // initializez cu ce am de la fii lui x, procesati inaintea lui f, apoi pun ce obtin de la f
			
			for ( int j = 1; j <= nr[f]; ++j )  // pt fiecare subarbore cu j noduri din f
				for ( int i = 1; i + j  <= nr[x]; i++ )  // pt fiecare numar de noduri i, posibil in x 
				{
					if ( A[i] == INF ) continue;
					if ( B[j] == INF ) continue;
				//	if ( A[i + j] > A[i] + B[j] - 2  ) // -2 pt ca a[x][i] si a[f][j] sunt calculate cu taierea muchiei intre x si f
				//		C[i + j] = A[i] + B[j] - 2;				
					C[i + j] = min(C[i + j], min(A[i] + B[j] - 2, A[i + j]));
				}
			A = C;	
		}
	if ( A[P] < minim ) 
		minim = A[P];
	return A;
}

void Read()
{
	ifstream fin("0-TREE.in");
	int son, father;
	cin >> n >> P;
	nr.resize(n + 1);
	t.resize(n + 1);
	sons.resize(n + 1);
	for ( int i = 1; i < n; ++i )
	{
		cin >> father >> son;
		t[son] = father;
		sons[father]++;
	}
	
	fin.close();
}
	


