#include <fstream>
#include <iomanip>
#include <vector>
using namespace std;

ofstream fout("arce.out");
#define INF 99999

typedef vector<int> VI;

int n, P;
VI t;
vector<VI> a;    // a[i][j] - nr min de arce care tr taiate pentru ca sa obtin un subarbore cu rad in x, avand j noduri
VI nr;     // nr[x] - nr noduri ale intregului subarbore cu rad in x
VI sons;
void Read();
void DF(int x);


int main()
{
	Read();
	for ( int i = 1; i <= n; ++i )
		for ( int j = 1; j <= n; ++j )
			a[i][j] = INF;
		
	DF(1);
	int minim = INF;
	for ( int i = 1; i <= n; ++i )
	{
		for ( int j = 1; j <= n; ++j )
		{
			
			if ( a[i][j] == INF )
				fout << setw(3 ) << "IN";
			else
				fout << setw(3 ) << a[i][j];
		}
		fout << '\n';
	}
	
	for (int i = 1; i <= n; ++i )
		if ( a[i][P] < minim )
			minim = a[i][P];
	fout << minim << '\n';
	
	fout.close();
	return 0;
}

void DF(int x)
{
	nr[x]++;

	a[x][1] = sons[x]; // ca sa raman doar cu nodul x in subarbore, tai muchiile spre fii
	if ( x != 1 ) a[x][1]++;  // daca nu e radacina, tai si nodul spre tata
	
	for (int f = 1; f <= n; ++f )
		if ( t[f] == x )
		{
			DF(f);
			VI A(a[x]); // initializez cu ce am de la fii lui x, procesati inaintea lui f, apoi pun ce obtin de la f
			
			for ( int i = 1; i  <= nr[x]; i++ )  // pt fiecare nr de noduri posibil in x f
				for ( int j = 1; j <= nr[f]; ++j )  // pt fiecare subarbore din f
				{
					if ( a[x][i] == INF ) continue;
					if ( a[f][j] == INF ) continue;
					if ( a[x][i + j] > a[x][i] + a[f][j] - 2  ) // -1 pt ca a[f][j] s-a calculat ca am taiat si muchia spre x
						A[i + j] = a[x][i] + a[f][j] - 2;
					else
					{
					//	if ( A[i + j] != INF )
					//	A[i + j]--; // tai muchia cu f 
					}
					
					
				}
			a[x] = A;
			nr[x] += nr[f];
		}
	
}

void Read()
{
	ifstream fin("arce.in");
	int son, father;
	fin >> n >> P;
	a.resize(n + 1000);
	nr.resize(n + 1000);
	t.resize(n + 1000);
	sons.resize(n + 1000);
	for ( int i = 1; i < n; ++i )
	{
		fin >> father >> son;
		t[son] = father;
		sons[father]++;
		a[i].resize(n + 1);
	}
	
	a[n].resize(n + 1);
	
	fin.close();
}
	


