#include <iterator>
#include <vector>

#include <iostream>
#include <fstream>
using namespace std;


typedef vector<int> VI;
typedef vector<pair<int, int> > VP;

vector<VP> G;   // graful
VI sons;        // nr fii
 

VI nf;          // nf[x] numar de frunze in subarb lui x
vector<VI> s;   // s[i][j] suma maxima in nodul x cu j frunze
VI S;           // sumele frunzelor
 
int n, A;       // noduri, abonati
void DF(int x);
void Read();

ifstream fin("5-tv.in");
ofstream fout("tv.out");


#define INF (0x3f3f3f3f)
//#define cin  fin
//#define cout fout


int main()
{
	Read();
	DF(1);	
/*	for ( int i = 1; i <= n; ++i )
	{
		for ( int j = 0; j <= A; ++j )
			fout << s[i][j] << " " ;
		fout << '\n';
	}
	
fout << '\n';
*/
	int nrf = 0;
	for (int i = A; i >= 1; --i )
		if ( s[1][i] >= 0 )
		{
			nrf = i;
			break;
		}
			
	
	
	cout << nrf << '\n';
/*	
	for ( int i = 1; i <= A; ++i )
		if ( s[1][i] == -INF )
			cout << "I ";
		else
			cout << s[1][i] << " ";
*/
	fout.close();
	fin.close();
	return 0;
}

void DF(int x)
{
	
	if ( !sons[x] ) 
	{
		nf[x] = 1;
		s[x][1] = S[x];
		return;
	}
	s[x][0] = 0; // la frunza nu pun
	
	for ( int k = 1; k <= sons[x]; ++k )
	{		
		int f = G[x][k].first;
		int cost = G[x][k].second;		
		DF(f);

		VI C(s[x]);  // ce am fara fiul f
				
		for ( int j = 1; j <= nf[f]; ++j )     // frunze luate din fiu
			for ( int i = 0; i + j <= A && i <= nf[x]; ++i ) // pt fiecare nr de frunze fara ultimul fiu
			{
				if ( /*s[x][i] == -INF ||*/ s[f][j] == -INF ) continue;
		//		cout << "i = " << i << "  j = " << j << "\n"; 
		//		cout << x << ' ' << f << ' ' << s[x][i] << ' ' << s[f][j] << ' ' << s[x][i + j] << ' ' << G[x][k].second; cin.get();	
				if ( s[x][i + j] < s[x][i] + s[f][j] - cost )
					C[i + j] = s[x][i] + s[f][j] - cost;
				//s[x][i + j] = max(s[x][i + j],  s[x][i] + s[f][j] - cost);
			}
		s[x] = C;
		nf[x] += nf[f];
		 
	}	
}
/*			
				cout << "i = " << i << "  j = " << j << "\n"; 
				cout << x << ' ' << f << ' ' << s[x][i] << ' ' << s[f][j] << ' ' << s[x][i + j] << ' ' << G[x][k].second; cin.get();
		*/		


void Read()
{
	cin >> n >> A;
	G.resize(n + 1); s.resize(n + 1);
	sons.resize(n + 1, 0); S.resize(n + 1);
	nf.resize(n + 1);
	for ( int i = 1; i <= n - A; ++i )
	{
		s[i].resize(A + 1, int(-INF));

		cin >> sons[i]; 
		G[i].resize(sons[i] + 1);

		for ( int j = 1; j <= sons[i]; ++j )
			cin >> G[i][j].first >> G[i][j].second;  // nod, cost
	}
	for (int i = 1; i <= A; ++i )
	{
	
		s[i + n - A].resize(A + 1, int(-INF));
		cin >> S[i + n - A];	
	}
}

