// Ia toate testele (nu aloca corect in BC 3.1)

#include <fstream.h>
#include <iomanip.h>


#define IN  "0-tv.in"
#define OUT "tv.out"
#define INFINIT 30000
#define abonat(A) ((A) > n-m ? 1 : 0)

typedef struct nod {
	short int vf;
	short int cost;
	nod* urm;
} NOD, *PNOD;

PNOD *L; // lista de vecibi
short int **temp, **total, *suma;
int n, m, rez, nnr, nr; // n, m <= 3000
int i, j, k;
void Citeste();
void Afiseaza();
void Add( int i, int j, int c);
int Max(int a, int b, int c);
int DF(int vf);

int main()
{
	Citeste();
	DF(1); // radacina este 1
	Afiseaza();

	return 0;
}

int DF(int vf)
{
	int nr = 0;  // nr frunze din subarb cu rad in vf
	for ( i = 1; i <= m; i++)
	  total[vf][i] = temp[vf][i] = -INFINIT;

	total[vf][0] = 0;
	for ( PNOD p = L[vf]; p; p = p->urm )
	{
		temp[vf][0] = 0;
		if ( abonat(p->vf) )
		{
			nr++;
			for ( i = 1; i <= nr; i++ )
				temp[vf][i] = Max(temp[vf][i], total[vf][i],
								  total[vf][i-1] - p->cost + suma[p->vf]);
		}
		else
		{
			nnr = DF(p->vf);
			nr += nnr;
			for ( i = 1; i <= nr; i++ )
				for ( k = 1; k <= nnr && k <= i; k++ )
					temp[vf][i] = Max(temp[vf][i], total[vf][i],
								  total[vf][i-k] - p->cost + total[p->vf][k]);

		}

		for ( i = 0; i <= nr;i++)
		{
			total[vf][i] = temp[vf][i];
			temp[vf][i] = -INFINIT;
		}

   }

   return nr;
}

void Aloc();

void Citeste()
{
	int grad, vecin, cost, i, j;
	ifstream fin(IN);
	fin >> n >> m;  // noduri, frunze
	Aloc();

	for ( i = 1; i <= n - m; i++ )
	{
		fin >> grad;
		for ( j = 0; j < grad; j++ )
		{
			fin >> vecin >> cost;
			Add(i, vecin, cost);
		}
	}

	for (i = n - m + 1; i <= n; i++ )
		fin >> suma[i];

	fin.close();
}


void Afiseaza(void)
{

	ofstream fout(OUT);
	rez = m;
	while (total[1][rez] < 0) rez--;

	fout << rez << "\n";
/*
	for  (i = 1; i <= n; i++ )
	{
		for ( j = 0; j <= m; j++ )
			fout << setw(6) << total[i][j];
		fout << "\n";
	}
*/

/*
	for ( PNOD p = L[1]; p; p = p->urm )
		fout << p->vf << " ";
*/
/*
	for ( i = 1; i <= n; i++ )
		fout << L[i] << " ";;
*/
	fout.close();
}

int Max(int a, int b, int c)
{
	if (a >= b && a >= c) return a;
	if (b >= a && b >= c) return b;
	return c;
}

void Aloc()
{
	int i;
	L = new PNOD [n + 1];
	memset(L, 0, sizeof(PNOD)*(n+1));

	suma = new short int [n + 1];

	temp = new short int* [n + 1];
	for (i = 0; i <= n; i++)
		temp[i] = new short int [m + 1];

	total = new short int* [n + 1];     // nr noduri
		for (i = 0; i <= n; i++)
			total[i] = new short int [m + 1]; // m nr max de frunze
}


void Add(int i, int j, int c)
{
	PNOD p = new NOD;
	p->vf = j;
	p->cost = c;
	p->urm = L[i];
	L[i] = p;
}

