

#include <stdio.h>
#include <vector>
#include <string.h>
#include <time.h>

using namespace std;

vector <int> X[128]; //the tree
int Mymin[128][128]; //the matrix

int i,j,n,m,k;

void readdata() //Read tree from input
{
	scanf ("%d%d", &n, &m);

	for (i = 1; i < n; i++)
	{
		int a, b;
		scanf ("%d%d", &a, &b);
		X[a].push_back(b);
		X[b].push_back(a);
	}
}

int pus[256];
int C[256];

#define nod X[x][i]

int MIN(int a, int b)
{
	if (a < b) return a;
	return b;
}

int MAX(int a, int b, int c)
{
	if (a >  b&& a > c) return a;
	if (b > c) return b;

	return c;
}

void doit(int x)
{
	int i;
	pus[x] = 1;

	for (i = 0; i < (int)X[x].size(); i++)
		if (!pus[nod]) doit(nod); //solve for sons first

	memset(Mymin[x], 1, sizeof(Mymin[x]));

    Mymin[x][1]=0; 

	for (i = 0; i < (int)X[x].size(); i++)
		if (pus[nod] == 2) //if the son was processed
		{
			int j,k;
			memset(C, 1, sizeof(C)); //auxiliar vector

			for (j = 0; j <= n;j++) 
				for ( k = n ;k >= 0; k--) // we've reached configuration (x,k) with the first nodes
					if (j + k <= n)    // now we can create another county with the node's left
					{			   // from configuration (nod,j) or add them to the other free(not in a county) nodes
								   // and get to configuration (x,k+j)
						//dont do it
						C[j+k] = MIN(C[j+k], MAX(Mymin[x][k], Mymin[nod][j], -123));
						//do it
						if (j > m) C[k] = MIN(C[k], MAX(Mymin[x][k], Mymin[nod][j],j));
					}
			memcpy(Mymin[x], C, sizeof(C));
		}
	pus[x] = 2; //we've solved x
}

void solve()
{
	doit(1);
}

void writedata()
{
	int best=1<<20;

	for (i=m;i<=n;i++)
		if (MAX(Mymin[1][i],i,-123)<best) best=MAX(Mymin[1][i],i,-123);

	printf ("%d\n",best);
}

int main()
{


	freopen ("judete.in","r",stdin);
	freopen ("judete.out","w",stdout);

	readdata();
	solve();
	writedata();
    
//	printf ("%lf\n",(double)((double)clock()-T1)/CLK_TCK);
	return 0;
}

