// OK ! fara sir auxiliar (rucsack de la sume mari la mici pentru evitarea multiplelor incluziuni)

#include <fstream>
#include <iostream>
#include <iomanip>
#include <vector>
using namespace std;

ofstream fout("tree.out");
#define INF 99999

typedef vector<int> VI;

int n, P;
VI t;
vector<VI> a;    // a[i][j] - nr min de arce care tr taiate pentru ca sa obtin un subarbore cu rad in x, avand j noduri
VI nr;     // nr[x] - nr noduri ale intregului subarbore cu rad in x
VI sons;
void Read();
void DF(int x);


int main()
{
	Read();
	for ( int i = 1; i <= n; ++i )
		for ( int j = 1; j <= n; ++j )
			a[i][j] = INF;
	if ( P == n )
	{
		cout << 0 << '\n';
		fout.close();
		return 0;
	}
	DF(1);
	int minim = INF;

	for (int i = 1; i <= n; ++i )
		if ( a[i][P] < minim )
			minim = a[i][P];
		cout << minim << '\n';
	
	fout.close();
	return 0;
}

void DF(int x)
{
	nr[x]++;
	a[x][1] = sons[x]; // ca sa raman doar cu nodul x in subarbore, tai muchiile spre fii
	if ( x != 1 ) 
		a[x][1]++;  // daca nu e radacina, tai si nodul spre tata
	for (int f = 1; f <= n; ++f )
		if ( t[f] == x )
		{	
			DF(f);
			nr[x] += nr[f];
			
			for ( int j = 1; j <= nr[f]; ++j )  // pt fiecare subarbore cu j noduri din f
				for ( int i = nr[x]; i >= 1; i-- )  // pt fiecare numar de noduri i, posibil in x 
				{
					if ( i + j > P ) continue;
					
					if ( a[x][i] == INF ) continue;
					if ( a[f][j] == INF ) continue;
					if ( a[x][i + j] > a[x][i] + a[f][j] - 2  ) 
						a[x][i + j] = a[x][i] + a[f][j] - 2;				
				}
		}
}

void Read()
{
	ifstream fin("0-TREE.in");
	int son, father;
	cin >> n >> P;
	a.resize(n + 1);
	nr.resize(n + 1);
	t.resize(n + 1);
	sons.resize(n + 1);
	for ( int i = 1; i < n; ++i )
	{
		cin >> father >> son;
		t[son] = father;
		sons[father]++;
		a[i].resize(n + 1);
	}
	
	a[n].resize(n + 1);
	
	fin.close();
}
	


