// OK - ies toate testele
#include <iterator>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fin("1-tv.in");
ofstream fout("tv.out");
//#define cin fin
//#define cout fout

const int INF = 0x3f3f3f3f;

int n, F; // noduri, frunze
typedef vector<int> VI;
typedef vector<pair<int, int> > VP;

vector<VP> G; // graful
VI S, nfz, sons;

void Read();
VI Df(int x);

int main()
{
	Read();
	vector<int> s = Df(1);
	int maxfr;	
	
	for ( int i = F; i >= 1;  --i)
		if ( s[i] >= 0 )
		{
			maxfr = i;
			break;
		}
		
	cout << maxfr << '\n';
/*
	for ( int i = 1; i <= n; ++i )
		cout << nfz[i] << ' ';
*/
	fout.close();
	fin.close();
	return 0;
}

vector<int> Df(int x)
{
	VI A(F + 1, -INF); // linia curenta a lui x

	if ( !sons[x] ) 
	{
		A[1] = S[x];
		nfz[x] = 1;
		return A;
	}
	A[0] = 0;   // daca tai toate frunzele nu cheltui nimic		
	for ( int k = 1; k <= sons[x]; ++k )
	{
		int f = G[x][k].first, cost = G[x][k].second; 
		VI B = Df(f);
		
		VI C(A);    
		
		for ( int j = 1; j <= nfz[f]; ++j )         // fiu
		for ( int i = 0; i + j <= F && i <= nfz[x]; ++i )    // x
		{
			if ( B[j] == -INF ) continue;
			if ( A[i] == -INF ) continue;
			
			C[i + j] = max(max(A[i + j], B[j] + A[i] - cost), C[i+j]);
		}
		A = C;
		nfz[x] += nfz[f];		
	}
//	cout << "\nx = " << x << " : ";
//	copy(A.begin(), A.end(), ostream_iterator<int>(cout, " "));
//	cout << '\n';
	return A;
}

void Read()
{
	cin >> n >> F;
	S.resize(n + 1); nfz.resize(n + 1); 
	sons.resize(n + 1); G.resize(n + 1);
	
	for ( int i = 1; i <= n; ++i )
	{
		G[i].resize(n + 1);
		if ( i <= n - F )
		{
			cin >> sons[i];
			for ( int j = 1; j <= sons[i]; ++j )
				cin >> G[i][j].first >> G[i][j].second;
		}
		else
			cin >> S[i];
	}
}
